from ctypes import *
TEMUSupport = CDLL('libTEMUSupport.so.4')

cpuGetFreq = TEMUSupport.temu_cpuGetFreq
cpuGetFreq.argtypes = [c_void_p]
cpuGetFreq.restype = c_uint64

cpuSetPc = TEMUSupport.temu_cpuSetPc
cpuSetPc.argtypes = [c_void_p, c_uint64]
cpuSetPc.restype = None

cpuGetPc = TEMUSupport.temu_cpuGetPc
cpuGetPc.argtypes = [c_void_p]
cpuGetPc.restype = c_uint64

cpuReset = TEMUSupport.temu_cpuReset
cpuReset.argtypes = [c_void_p, c_int]
cpuReset.restype = None

cpuRun = TEMUSupport.temu_cpuRun
cpuRun.argtypes = [c_void_p, c_uint64]
cpuRun.restype = c_uint64

cpuStep = TEMUSupport.temu_cpuStep
cpuStep.argtypes = [c_void_p, c_uint64]
cpuStep.restype = c_uint64

cpuTranslateAddress = TEMUSupport.temu_cpuTranslateAddress
cpuTranslateAddress.argtypes = [c_void_p, c_uint64, c_uint32, POINTER(c_uint64)]
cpuTranslateAddress.restype = c_int

cpuGetReg = TEMUSupport.temu_cpuGetReg
cpuGetReg.argtypes = [c_void_p, c_uint]
cpuGetReg.restype = c_uint64

cpuSetReg = TEMUSupport.temu_cpuSetReg
cpuSetReg.argtypes = [c_void_p, c_uint, c_uint64]
cpuSetReg.restype = None

cpuGetFpr32 = TEMUSupport.temu_cpuGetFpr32
cpuGetFpr32.argtypes = [c_void_p, c_uint]
cpuGetFpr32.restype = c_float

cpuGetFpr32Bits = TEMUSupport.temu_cpuGetFpr32Bits
cpuGetFpr32Bits.argtypes = [c_void_p, c_uint]
cpuGetFpr32Bits.restype = c_uint32

cpuSetFpr32 = TEMUSupport.temu_cpuSetFpr32
cpuSetFpr32.argtypes = [c_void_p, c_uint, c_float]
cpuSetFpr32.restype = None

cpuSetFpr32Bits = TEMUSupport.temu_cpuSetFpr32Bits
cpuSetFpr32Bits.argtypes = [c_void_p, c_uint, c_uint32]
cpuSetFpr32Bits.restype = None

cpuGetFpr64 = TEMUSupport.temu_cpuGetFpr64
cpuGetFpr64.argtypes = [c_void_p, c_uint]
cpuGetFpr64.restype = c_double

cpuGetFpr64Bits = TEMUSupport.temu_cpuGetFpr64Bits
cpuGetFpr64Bits.argtypes = [c_void_p, c_uint]
cpuGetFpr64Bits.restype = c_uint64

cpuSetFpr64 = TEMUSupport.temu_cpuSetFpr64
cpuSetFpr64.argtypes = [c_void_p, c_uint, c_double]
cpuSetFpr64.restype = None

cpuSetFpr64Bits = TEMUSupport.temu_cpuSetFpr64Bits
cpuSetFpr64Bits.argtypes = [c_void_p, c_uint, c_uint64]
cpuSetFpr64Bits.restype = None

cpuEnableTraps = TEMUSupport.temu_cpuEnableTraps
cpuEnableTraps.argtypes = [c_void_p]
cpuEnableTraps.restype = None

cpuDisableTraps = TEMUSupport.temu_cpuDisableTraps
cpuDisableTraps.argtypes = [c_void_p]
cpuDisableTraps.restype = None

cpuRaiseTrap = TEMUSupport.temu_cpuRaiseTrap
cpuRaiseTrap.argtypes = [c_void_p, c_int, c_uint]
cpuRaiseTrap.restype = None

SparcAsrHandler = CFUNCTYPE(None, c_void_p, c_uint32)

sparcGetWindowCount = TEMUSupport.temu_sparcGetWindowCount
sparcGetWindowCount.argtypes = [c_void_p]
sparcGetWindowCount.restype = c_int

sparcGetWindowedReg = TEMUSupport.temu_sparcGetWindowedReg
sparcGetWindowedReg.argtypes = [c_void_p, c_int, c_uint]
sparcGetWindowedReg.restype = c_uint32

sparcSetWindowedReg = TEMUSupport.temu_sparcSetWindowedReg
sparcSetWindowedReg.argtypes = [c_void_p, c_int, c_uint, c_uint32]
sparcSetWindowedReg.restype = None

sparcSetY = TEMUSupport.temu_sparcSetY
sparcSetY.argtypes = [c_void_p, c_uint64]
sparcSetY.restype = None

sparcGetY = TEMUSupport.temu_sparcGetY
sparcGetY.argtypes = [c_void_p]
sparcGetY.restype = c_uint64

sparcSetAsr = TEMUSupport.temu_sparcSetAsr
sparcSetAsr.argtypes = [c_void_p, c_uint, c_uint64]
sparcSetAsr.restype = None

sparcGetAsr = TEMUSupport.temu_sparcGetAsr
sparcGetAsr.argtypes = [c_void_p, c_uint]
sparcGetAsr.restype = c_uint64

sparcSetAsrWriter = TEMUSupport.temu_sparcSetAsrWriter
sparcSetAsrWriter.argtypes = [c_void_p, c_uint, CFUNCTYPE(None, c_void_p, c_uint32)]
sparcSetAsrWriter.restype = None

sparcSetAsrReader = TEMUSupport.temu_sparcSetAsrReader
sparcSetAsrReader.argtypes = [c_void_p, c_uint, CFUNCTYPE(None, c_void_p, c_uint32)]
sparcSetAsrReader.restype = None

sparcSetPsr = TEMUSupport.temu_sparcSetPsr
sparcSetPsr.argtypes = [c_void_p, c_uint32]
sparcSetPsr.restype = None

sparcGetPsr = TEMUSupport.temu_sparcGetPsr
sparcGetPsr.argtypes = [c_void_p]
sparcGetPsr.restype = c_uint32

sparcSetTbr = TEMUSupport.temu_sparcSetTbr
sparcSetTbr.argtypes = [c_void_p, c_uint32]
sparcSetTbr.restype = None

sparcGetTbr = TEMUSupport.temu_sparcGetTbr
sparcGetTbr.argtypes = [c_void_p]
sparcGetTbr.restype = c_uint32

sparcSetWim = TEMUSupport.temu_sparcSetWim
sparcSetWim.argtypes = [c_void_p, c_uint32]
sparcSetWim.restype = None

sparcGetWim = TEMUSupport.temu_sparcGetWim
sparcGetWim.argtypes = [c_void_p]
sparcGetWim.restype = c_uint32

sparcSetNPc = TEMUSupport.temu_sparcSetNPc
sparcSetNPc.argtypes = [c_void_p, c_uint32]
sparcSetNPc.restype = None

sparcGetNPc = TEMUSupport.temu_sparcGetNPc
sparcGetNPc.argtypes = [c_void_p]
sparcGetNPc.restype = c_uint32

armSetAPSR = TEMUSupport.temu_armSetAPSR
armSetAPSR.argtypes = [c_void_p, c_uint32]
armSetAPSR.restype = None

armGetAPSR = TEMUSupport.temu_armGetAPSR
armGetAPSR.argtypes = [c_void_p]
armGetAPSR.restype = c_uint32

armSetFPSCR = TEMUSupport.temu_armSetFPSCR
armSetFPSCR.argtypes = [c_void_p, c_uint32]
armSetFPSCR.restype = None

armGetFPSCR = TEMUSupport.temu_armGetFPSCR
armGetFPSCR.argtypes = [c_void_p]
armGetFPSCR.restype = c_uint32

armSetFPEXC = TEMUSupport.temu_armSetFPEXC
armSetFPEXC.argtypes = [c_void_p, c_uint32]
armSetFPEXC.restype = None

armGetFPEXC = TEMUSupport.temu_armGetFPEXC
armGetFPEXC.argtypes = [c_void_p]
armGetFPEXC.restype = c_uint32

armSetFPINST = TEMUSupport.temu_armSetFPINST
armSetFPINST.argtypes = [c_void_p, c_int, c_uint32]
armSetFPINST.restype = None

armGetFPINST = TEMUSupport.temu_armGetFPINST
armGetFPINST.argtypes = [c_void_p, c_int]
armGetFPINST.restype = c_uint32

armGetExecMode = TEMUSupport.temu_armGetExecMode
armGetExecMode.argtypes = [c_void_p]
armGetExecMode.restype = c_uint

armSetExecMode = TEMUSupport.temu_armSetExecMode
armSetExecMode.argtypes = [c_void_p, c_uint]
armSetExecMode.restype = None

ppcSetCrReg = TEMUSupport.temu_ppcSetCrReg
ppcSetCrReg.argtypes = [c_void_p, c_uint32]
ppcSetCrReg.restype = None

ppcGetCrReg = TEMUSupport.temu_ppcGetCrReg
ppcGetCrReg.argtypes = [c_void_p]
ppcGetCrReg.restype = c_uint32

ppcSetXerReg = TEMUSupport.temu_ppcSetXerReg
ppcSetXerReg.argtypes = [c_void_p, c_uint32]
ppcSetXerReg.restype = None

ppcGetXerReg = TEMUSupport.temu_ppcGetXerReg
ppcGetXerReg.argtypes = [c_void_p]
ppcGetXerReg.restype = c_uint32

ppcSetMsrReg = TEMUSupport.temu_ppcSetMsrReg
ppcSetMsrReg.argtypes = [c_void_p, c_uint64]
ppcSetMsrReg.restype = None

ppcGetMsrReg = TEMUSupport.temu_ppcGetMsrReg
ppcGetMsrReg.argtypes = [c_void_p]
ppcGetMsrReg.restype = c_uint64

ppcSetReserveAddress = TEMUSupport.temu_ppcSetReserveAddress
ppcSetReserveAddress.argtypes = [c_void_p, c_uint64]
ppcSetReserveAddress.restype = None

ppcGetReserveAddress = TEMUSupport.temu_ppcGetReserveAddress
ppcGetReserveAddress.argtypes = [c_void_p]
ppcGetReserveAddress.restype = c_uint64

ppcClearAddressReservation = TEMUSupport.temu_ppcClearAddressReservation
ppcClearAddressReservation.argtypes = [c_void_p]
ppcClearAddressReservation.restype = None

ppcIsReservationBitSet = TEMUSupport.temu_ppcIsReservationBitSet
ppcIsReservationBitSet.argtypes = [c_void_p]
ppcIsReservationBitSet.restype = c_int

ppcSetCtrReg = TEMUSupport.temu_ppcSetCtrReg
ppcSetCtrReg.argtypes = [c_void_p, c_uint32]
ppcSetCtrReg.restype = None

ppcGetCtrReg = TEMUSupport.temu_ppcGetCtrReg
ppcGetCtrReg.argtypes = [c_void_p]
ppcGetCtrReg.restype = c_uint32

ppcSetFpscrReg = TEMUSupport.temu_ppcSetFpscrReg
ppcSetFpscrReg.argtypes = [c_void_p, c_uint32]
ppcSetFpscrReg.restype = None

ppcGetFpscrReg = TEMUSupport.temu_ppcGetFpscrReg
ppcGetFpscrReg.argtypes = [c_void_p]
ppcGetFpscrReg.restype = c_uint32

ppcSetLrReg = TEMUSupport.temu_ppcSetLrReg
ppcSetLrReg.argtypes = [c_void_p, c_uint64]
ppcSetLrReg.restype = None

ppcGetLrReg = TEMUSupport.temu_ppcGetLrReg
ppcGetLrReg.argtypes = [c_void_p]
ppcGetLrReg.restype = c_uint64

cpuSetSpr = TEMUSupport.temu_cpuSetSpr
cpuSetSpr.argtypes = [c_void_p, c_uint, c_uint64]
cpuSetSpr.restype = None

cpuGetSpr = TEMUSupport.temu_cpuGetSpr
cpuGetSpr.argtypes = [c_void_p, c_uint]
cpuGetSpr.restype = c_uint64

cpuGetMachine = TEMUSupport.temu_cpuGetMachine
cpuGetMachine.argtypes = [c_void_p]
cpuGetMachine.restype = c_void_p

machineReset = TEMUSupport.temu_machineReset
machineReset.argtypes = [c_void_p, c_int]
machineReset.restype = None

machineRun = TEMUSupport.temu_machineRun
machineRun.argtypes = [c_void_p, c_uint64]
machineRun.restype = c_uint64

SafeCb = CFUNCTYPE(None, c_void_p)

postCallback = TEMUSupport.temu_postCallback
postCallback.argtypes = [c_void_p, CFUNCTYPE(None, c_void_p), c_void_p]
postCallback.restype = None

cpuGetStat = TEMUSupport.temu_cpuGetStat
cpuGetStat.argtypes = [c_void_p, c_int]
cpuGetStat.restype = c_uint64

cpuResetStat = TEMUSupport.temu_cpuResetStat
cpuResetStat.argtypes = [c_void_p, c_int]
cpuResetStat.restype = None

from ctypes import *
TEMUSupport = CDLL('libTEMUSupport.so.4')

cpuGetFreq = TEMUSupport.temu_cpuGetFreq
cpuGetFreq.argtypes = [c_void_p]
cpuGetFreq.restype = c_uint64

cpuSetPc = TEMUSupport.temu_cpuSetPc
cpuSetPc.argtypes = [c_void_p, c_uint64]
cpuSetPc.restype = None

cpuGetPc = TEMUSupport.temu_cpuGetPc
cpuGetPc.argtypes = [c_void_p]
cpuGetPc.restype = c_uint64

cpuReset = TEMUSupport.temu_cpuReset
cpuReset.argtypes = [c_void_p, c_int]
cpuReset.restype = None

cpuRun = TEMUSupport.temu_cpuRun
cpuRun.argtypes = [c_void_p, c_uint64]
cpuRun.restype = c_uint64

cpuStep = TEMUSupport.temu_cpuStep
cpuStep.argtypes = [c_void_p, c_uint64]
cpuStep.restype = c_uint64

cpuTranslateAddress = TEMUSupport.temu_cpuTranslateAddress
cpuTranslateAddress.argtypes = [c_void_p, c_uint64, c_uint32, POINTER(c_uint64)]
cpuTranslateAddress.restype = c_int

cpuGetReg = TEMUSupport.temu_cpuGetReg
cpuGetReg.argtypes = [c_void_p, c_uint]
cpuGetReg.restype = c_uint64

cpuSetReg = TEMUSupport.temu_cpuSetReg
cpuSetReg.argtypes = [c_void_p, c_uint, c_uint64]
cpuSetReg.restype = None

cpuGetFpr32 = TEMUSupport.temu_cpuGetFpr32
cpuGetFpr32.argtypes = [c_void_p, c_uint]
cpuGetFpr32.restype = c_float

cpuGetFpr32Bits = TEMUSupport.temu_cpuGetFpr32Bits
cpuGetFpr32Bits.argtypes = [c_void_p, c_uint]
cpuGetFpr32Bits.restype = c_uint32

cpuSetFpr32 = TEMUSupport.temu_cpuSetFpr32
cpuSetFpr32.argtypes = [c_void_p, c_uint, c_float]
cpuSetFpr32.restype = None

cpuSetFpr32Bits = TEMUSupport.temu_cpuSetFpr32Bits
cpuSetFpr32Bits.argtypes = [c_void_p, c_uint, c_uint32]
cpuSetFpr32Bits.restype = None

cpuGetFpr64 = TEMUSupport.temu_cpuGetFpr64
cpuGetFpr64.argtypes = [c_void_p, c_uint]
cpuGetFpr64.restype = c_double

cpuGetFpr64Bits = TEMUSupport.temu_cpuGetFpr64Bits
cpuGetFpr64Bits.argtypes = [c_void_p, c_uint]
cpuGetFpr64Bits.restype = c_uint64

cpuSetFpr64 = TEMUSupport.temu_cpuSetFpr64
cpuSetFpr64.argtypes = [c_void_p, c_uint, c_double]
cpuSetFpr64.restype = None

cpuSetFpr64Bits = TEMUSupport.temu_cpuSetFpr64Bits
cpuSetFpr64Bits.argtypes = [c_void_p, c_uint, c_uint64]
cpuSetFpr64Bits.restype = None

cpuEnableTraps = TEMUSupport.temu_cpuEnableTraps
cpuEnableTraps.argtypes = [c_void_p]
cpuEnableTraps.restype = None

cpuDisableTraps = TEMUSupport.temu_cpuDisableTraps
cpuDisableTraps.argtypes = [c_void_p]
cpuDisableTraps.restype = None

cpuRaiseTrap = TEMUSupport.temu_cpuRaiseTrap
cpuRaiseTrap.argtypes = [c_void_p, c_int, c_uint]
cpuRaiseTrap.restype = None

SparcAsrHandler = CFUNCTYPE(None, c_void_p, c_uint32)

sparcGetWindowCount = TEMUSupport.temu_sparcGetWindowCount
sparcGetWindowCount.argtypes = [c_void_p]
sparcGetWindowCount.restype = c_int

sparcGetWindowedReg = TEMUSupport.temu_sparcGetWindowedReg
sparcGetWindowedReg.argtypes = [c_void_p, c_int, c_uint]
sparcGetWindowedReg.restype = c_uint32

sparcSetWindowedReg = TEMUSupport.temu_sparcSetWindowedReg
sparcSetWindowedReg.argtypes = [c_void_p, c_int, c_uint, c_uint32]
sparcSetWindowedReg.restype = None

sparcSetY = TEMUSupport.temu_sparcSetY
sparcSetY.argtypes = [c_void_p, c_uint64]
sparcSetY.restype = None

sparcGetY = TEMUSupport.temu_sparcGetY
sparcGetY.argtypes = [c_void_p]
sparcGetY.restype = c_uint64

sparcSetAsr = TEMUSupport.temu_sparcSetAsr
sparcSetAsr.argtypes = [c_void_p, c_uint, c_uint64]
sparcSetAsr.restype = None

sparcGetAsr = TEMUSupport.temu_sparcGetAsr
sparcGetAsr.argtypes = [c_void_p, c_uint]
sparcGetAsr.restype = c_uint64

sparcSetAsrWriter = TEMUSupport.temu_sparcSetAsrWriter
sparcSetAsrWriter.argtypes = [c_void_p, c_uint, CFUNCTYPE(None, c_void_p, c_uint32)]
sparcSetAsrWriter.restype = None

sparcSetAsrReader = TEMUSupport.temu_sparcSetAsrReader
sparcSetAsrReader.argtypes = [c_void_p, c_uint, CFUNCTYPE(None, c_void_p, c_uint32)]
sparcSetAsrReader.restype = None

sparcSetPsr = TEMUSupport.temu_sparcSetPsr
sparcSetPsr.argtypes = [c_void_p, c_uint32]
sparcSetPsr.restype = None

sparcGetPsr = TEMUSupport.temu_sparcGetPsr
sparcGetPsr.argtypes = [c_void_p]
sparcGetPsr.restype = c_uint32

sparcSetTbr = TEMUSupport.temu_sparcSetTbr
sparcSetTbr.argtypes = [c_void_p, c_uint32]
sparcSetTbr.restype = None

sparcGetTbr = TEMUSupport.temu_sparcGetTbr
sparcGetTbr.argtypes = [c_void_p]
sparcGetTbr.restype = c_uint32

sparcSetWim = TEMUSupport.temu_sparcSetWim
sparcSetWim.argtypes = [c_void_p, c_uint32]
sparcSetWim.restype = None

sparcGetWim = TEMUSupport.temu_sparcGetWim
sparcGetWim.argtypes = [c_void_p]
sparcGetWim.restype = c_uint32

sparcSetNPc = TEMUSupport.temu_sparcSetNPc
sparcSetNPc.argtypes = [c_void_p, c_uint32]
sparcSetNPc.restype = None

sparcGetNPc = TEMUSupport.temu_sparcGetNPc
sparcGetNPc.argtypes = [c_void_p]
sparcGetNPc.restype = c_uint32

armSetAPSR = TEMUSupport.temu_armSetAPSR
armSetAPSR.argtypes = [c_void_p, c_uint32]
armSetAPSR.restype = None

armGetAPSR = TEMUSupport.temu_armGetAPSR
armGetAPSR.argtypes = [c_void_p]
armGetAPSR.restype = c_uint32

armSetFPSCR = TEMUSupport.temu_armSetFPSCR
armSetFPSCR.argtypes = [c_void_p, c_uint32]
armSetFPSCR.restype = None

armGetFPSCR = TEMUSupport.temu_armGetFPSCR
armGetFPSCR.argtypes = [c_void_p]
armGetFPSCR.restype = c_uint32

armSetFPEXC = TEMUSupport.temu_armSetFPEXC
armSetFPEXC.argtypes = [c_void_p, c_uint32]
armSetFPEXC.restype = None

armGetFPEXC = TEMUSupport.temu_armGetFPEXC
armGetFPEXC.argtypes = [c_void_p]
armGetFPEXC.restype = c_uint32

armSetFPINST = TEMUSupport.temu_armSetFPINST
armSetFPINST.argtypes = [c_void_p, c_int, c_uint32]
armSetFPINST.restype = None

armGetFPINST = TEMUSupport.temu_armGetFPINST
armGetFPINST.argtypes = [c_void_p, c_int]
armGetFPINST.restype = c_uint32

armGetExecMode = TEMUSupport.temu_armGetExecMode
armGetExecMode.argtypes = [c_void_p]
armGetExecMode.restype = c_uint

armSetExecMode = TEMUSupport.temu_armSetExecMode
armSetExecMode.argtypes = [c_void_p, c_uint]
armSetExecMode.restype = None

ppcSetCrReg = TEMUSupport.temu_ppcSetCrReg
ppcSetCrReg.argtypes = [c_void_p, c_uint32]
ppcSetCrReg.restype = None

ppcGetCrReg = TEMUSupport.temu_ppcGetCrReg
ppcGetCrReg.argtypes = [c_void_p]
ppcGetCrReg.restype = c_uint32

ppcSetXerReg = TEMUSupport.temu_ppcSetXerReg
ppcSetXerReg.argtypes = [c_void_p, c_uint32]
ppcSetXerReg.restype = None

ppcGetXerReg = TEMUSupport.temu_ppcGetXerReg
ppcGetXerReg.argtypes = [c_void_p]
ppcGetXerReg.restype = c_uint32

ppcSetMsrReg = TEMUSupport.temu_ppcSetMsrReg
ppcSetMsrReg.argtypes = [c_void_p, c_uint64]
ppcSetMsrReg.restype = None

ppcGetMsrReg = TEMUSupport.temu_ppcGetMsrReg
ppcGetMsrReg.argtypes = [c_void_p]
ppcGetMsrReg.restype = c_uint64

ppcSetReserveAddress = TEMUSupport.temu_ppcSetReserveAddress
ppcSetReserveAddress.argtypes = [c_void_p, c_uint64]
ppcSetReserveAddress.restype = None

ppcGetReserveAddress = TEMUSupport.temu_ppcGetReserveAddress
ppcGetReserveAddress.argtypes = [c_void_p]
ppcGetReserveAddress.restype = c_uint64

ppcClearAddressReservation = TEMUSupport.temu_ppcClearAddressReservation
ppcClearAddressReservation.argtypes = [c_void_p]
ppcClearAddressReservation.restype = None

ppcIsReservationBitSet = TEMUSupport.temu_ppcIsReservationBitSet
ppcIsReservationBitSet.argtypes = [c_void_p]
ppcIsReservationBitSet.restype = c_int

ppcSetCtrReg = TEMUSupport.temu_ppcSetCtrReg
ppcSetCtrReg.argtypes = [c_void_p, c_uint32]
ppcSetCtrReg.restype = None

ppcGetCtrReg = TEMUSupport.temu_ppcGetCtrReg
ppcGetCtrReg.argtypes = [c_void_p]
ppcGetCtrReg.restype = c_uint32

ppcSetFpscrReg = TEMUSupport.temu_ppcSetFpscrReg
ppcSetFpscrReg.argtypes = [c_void_p, c_uint32]
ppcSetFpscrReg.restype = None

ppcGetFpscrReg = TEMUSupport.temu_ppcGetFpscrReg
ppcGetFpscrReg.argtypes = [c_void_p]
ppcGetFpscrReg.restype = c_uint32

ppcSetLrReg = TEMUSupport.temu_ppcSetLrReg
ppcSetLrReg.argtypes = [c_void_p, c_uint64]
ppcSetLrReg.restype = None

ppcGetLrReg = TEMUSupport.temu_ppcGetLrReg
ppcGetLrReg.argtypes = [c_void_p]
ppcGetLrReg.restype = c_uint64

cpuSetSpr = TEMUSupport.temu_cpuSetSpr
cpuSetSpr.argtypes = [c_void_p, c_uint, c_uint64]
cpuSetSpr.restype = None

cpuGetSpr = TEMUSupport.temu_cpuGetSpr
cpuGetSpr.argtypes = [c_void_p, c_uint]
cpuGetSpr.restype = c_uint64

cpuGetMachine = TEMUSupport.temu_cpuGetMachine
cpuGetMachine.argtypes = [c_void_p]
cpuGetMachine.restype = c_void_p

machineReset = TEMUSupport.temu_machineReset
machineReset.argtypes = [c_void_p, c_int]
machineReset.restype = None

machineRun = TEMUSupport.temu_machineRun
machineRun.argtypes = [c_void_p, c_uint64]
machineRun.restype = c_uint64

SafeCb = CFUNCTYPE(None, c_void_p)

postCallback = TEMUSupport.temu_postCallback
postCallback.argtypes = [c_void_p, CFUNCTYPE(None, c_void_p), c_void_p]
postCallback.restype = None

cpuGetStat = TEMUSupport.temu_cpuGetStat
cpuGetStat.argtypes = [c_void_p, c_int]
cpuGetStat.restype = c_uint64

cpuResetStat = TEMUSupport.temu_cpuResetStat
cpuResetStat.argtypes = [c_void_p, c_int]
cpuResetStat.restype = None

